# Compiler options (TypeScript 2.9.2)
## Major options

Show with `tsc --help` and have a short version.

| Short | Long | Description |
|-------|------|-------------|
| -d | --declaration | Generate a `.d.ts` file |
| -m kind | --module kind | **`none`** `commonjs` `amd` `system` `umd` `es2015` `ESNext` |
| -p file_or_dir | --project --file_or_dir | Use configuration from the file or the `tsconfig.json` found in the directory |
| -t VERSION | --target VERSION | **`ES3`** `ES5` `ES2015` `ES2016` `ES2017` `ES2018` `ESNEXT` |
| -w | --watch | Watch for changed files and compile incrementally |


## Normal options 

Show with `tsc --help` but no short version.

| Long | Description |
|------|-------------|
| --init | Create a default `tsconfig.json` |
| --noImplicitAny | Throw on expressions and declarations with an implicit `any` type |
| --noImplicitReturns | Throw when some code paths do not return a value |
| --noImplicitThis | Throw on untyped `this` expressions |
| --outDir dir | Directory in which to output the individual compiled files |
| --outFile file | File in which to output the aggregated compiled files |


## Unlisted options

Shown with `tsc --all` but not `tsc --help``

| Long | Description |
|------|-------------|
| --moduleResolution | `node` (like NodeJS with `commonjs` modules), or `classic` (pre-TS1.6) 

## Older options

Documented in 2016 course, but not available in 2.9.2

| Short | Long | Description |
|-------|------|-------------|
 |
